package ru.dbotthepony.kbox2d.api

/**
 * Input parameters for b2TimeOfImpact
 */
data class TOIInput(
	var proxyA: IDistanceProxy,
	var proxyB: IDistanceProxy,
	var sweepA: Sweep,
	var sweepB: Sweep,
	var tMax: Double,		// defines sweep interval [0, tMax]
)

/**
 * Output parameters for b2TimeOfImpact.
 */
data class TOIOutput(
	val state: State,
	val t: Double,
) {
	enum class State {
		UNKNOWN,
		FAILED,
		OVERLAPPED,
		TOUCHING,
		SEPARATED
	}
}
