package ru.dbotthepony.kstarbound.math

import com.google.common.collect.ImmutableList
import com.google.gson.TypeAdapter
import com.google.gson.stream.JsonReader
import com.google.gson.stream.JsonToken
import com.google.gson.stream.JsonWriter

class Poly(vararg points: Vector2d) {
	val points: List<Vector2d> = ImmutableList.copyOf(points)

	override fun toString(): String {
		return "Poly($points)"
	}
}

object PolyTypeAdapter : TypeAdapter<Poly>() {
	override fun write(out: JsonWriter, value: Poly) {
		`out`.beginArray()

		for (point in value.points) {
			Vector2dTypeAdapter.write(out, point)
		}

		`out`.endArray()
	}

	override fun read(`in`: JsonReader): Poly {
		`in`.beginArray()

		val points = mutableListOf<Vector2d>()

		while (`in`.peek() == JsonToken.BEGIN_ARRAY) {
			points.add(Vector2dTypeAdapter.read(`in`))
		}

		`in`.endArray()

		return Poly(*points.toTypedArray())
	}
}
